#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <unistd.h>
#include <ftd2xx.h>
#pragma comment(lib, "ftd2xx")
#include <FTDI_FUNCTIONS.h>
#include <time.h>

FT_HANDLE ftHandle;
FT_STATUS ftStatus;

int OPEN_FTDI(void){
	ftStatus = FT_OpenEx("FTWMPJZD", FT_OPEN_BY_SERIAL_NUMBER, &ftHandle); 
	if(ftStatus != FT_OK) { 
		// FT_Open failed 
		printf("FT_Open failed \r\n");
		return 0; 
	} else {
		printf("FT_Open OK \r\n");
		return 1;
	}
}

void INIT_FTDI(void){
	UCHAR Mask = 0xFF;
	UCHAR Mode;

	Mode = 0x00; //reset mode
	ftStatus = FT_SetBitMode(ftHandle, Mask, Mode);
	if (ftStatus == FT_OK) { 
		printf("RST_OK\r\n");
	} else { 
		printf("RST FT_SetBitMode FAILED! \r\n");
	}
	sleep(1);
	
	Mode = 0x40;
	ftStatus = FT_SetBitMode(ftHandle, Mask, Mode); 
	if (ftStatus == FT_OK) { 
		printf("0x00 written to device\r\n");
	} else { 
		printf("FT_SetBitMode FAILED! \r\n");
	}

	UCHAR Latency = 0x02;
	ftStatus = FT_SetLatencyTimer(ftHandle, Latency); 
	if (ftStatus == FT_OK) {  
		printf("Latency is set\r\n");
	} else { 
		printf("FT_SetLatencyTime FAILED! \r\n");
	} 

	DWORD InTransferSize = 0x10000;
	DWORD OutTransferSize = 0x10000;
	ftStatus = FT_SetUSBParameters(ftHandle, InTransferSize, OutTransferSize); 
	if (ftStatus == FT_OK) { 
		printf("Size is set\r\n");
	} else { 
		printf("FT_SetUSBParameters FAILED! \r\n");
	}

	ftStatus = FT_SetResetPipeRetryCount(ftHandle, 50);
	if (ftStatus == FT_OK) { 
		printf("SetResetPipeRetryCount is set\r\n");
	} else { 
		printf("FT_SetResetPipeRetryCount FAILED! \r\n");
	}

	ftStatus = FT_SetFlowControl(ftHandle, FT_FLOW_RTS_CTS, 0x00, 0x00);
	if (ftStatus == FT_OK) { 
		printf("FLOW Control is set\r\n");
	} else { 
		printf("FT_SetFlowControl FAILED! \r\n");
	} 

	ftStatus = FT_SetTimeouts(ftHandle, 0, 0);
	if (ftStatus == FT_OK) { 
		printf("Timeouts is set\r\n");
	} else {  
		printf("FT_SetTimeouts FAILED! \r\n");
	} 
}

void PURGE_FTDI(void){
	FT_Purge(ftHandle, FT_PURGE_RX);
	//FT_Purge(ftHandle, FT_PURGE_TX);
}

void CLOSE_FTDI(void){
	FT_SetBitMode(ftHandle, 0, 0);
	FT_Close(ftHandle);
}

void WRITE_DATA(LPVOID TxBuffer, int Bytes_to_send, LPDWORD BytesWritten){
	DWORD EventDWord;
	DWORD RxBytes;
	DWORD TxBytes;
	while(1){
		ftStatus = FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
		//printf("RxBytes    = %lu\r\n", RxBytes);
		//printf("TxBytes    = %lu\r\n", TxBytes);
		//printf("EventDWord = %lu\r\n", EventDWord);
		if((ftStatus == FT_OK) && (TxBytes == 0)){
			ftStatus = FT_Write(ftHandle, TxBuffer, Bytes_to_send, BytesWritten);
			if (ftStatus != FT_OK){
				printf("WRITE FAILED\r\n");
			}
			//break;
		}
		//check the end condition and quit
		break;
	}
}

void READ_DATA(LPVOID RxBuffer, int Bytes_to_read, LPDWORD BytesReceived){
	DWORD EventDWord;
	DWORD RxBytes;
	DWORD TxBytes;
	unsigned int TEMP_TIME;
	TEMP_TIME = clock();
	while(1){
		ftStatus = FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
		/*printf("RxBytes    = %lu\r\n", RxBytes);
		printf("TxBytes    = %lu\r\n", TxBytes);
		printf("EventDWord = %lu\r\n", EventDWord);
		*/
		//printf("hallo3\r\n");
		if((ftStatus == FT_OK) && (RxBytes >= Bytes_to_read)){
			ftStatus = FT_Read(ftHandle,RxBuffer,Bytes_to_read,BytesReceived);
			if (ftStatus != FT_OK){
				printf("READ FAILED\r\n");
			}
			break;
		}
		//printf("hallo4\r\n");
		if(clock() > (TEMP_TIME + 1000)){
			break;
		}
	}
}
